import QtQuick 2.0
import MuseScore 3.0
import FileIO 3.0 

MuseScore {
	description: "Musicxml Parser"
	menuPath: "Plugins.MusicxmlParser"
	version: "1.0"
    requiresScore: true
	 
	property var mxPath : "";
	FileIO { id: fid; source: mxPath }
	
	FileIO {
            id: outfile
            source: tempPath() + "/ObjectExplorer.log"
            onError: console.log(msg)
      }  
	  // tempath() =  C:/Users/Dirk/AppData/Local/Temp/ObjectExplorer.log
      QProcess {
        id: proc
        }
            
      property variant output: "" 
	  
	// convert ...>s<... to s
	function strip(s){
		var i = s.search(">")
		s = s.substring(i+1);
		var i = s.search("<")
		s = s.substring(0,i);
		return s
	}
		
	function abs(num){
		if (num < 0) return -num
		return num
	}
	
	function check(toCheck,i,ticks, mticks, divisions){
		var s = toCheck[1]
		var line = ticks[i].line
		var tick = ticks[i].tick
		var type = ticks[i].type
		var voice = ticks[i].voice
		var mlen
		var result
		var noise = 10
		var keys = ["Gb", "Db", "Ab", "Eb", "Bb", "F", "C", "G", "D", "A", "E", "B", "F#"]
				
		var j = line.indexOf(s)
		// found a match
		if (j != -1){
			//console.log("55 j s line = ", j + " " + s + " " + line)
			switch (s) {
				case "<beat-unit":	
					tick += (+ticks[i].duration)
					s = strip(line)
					var s2 = ticks[(+i)+1].line
					s2 = strip(s2)				
					s = toCheck[0] + ": " + s2 + " beats per minute for a " + s + "note"
				break;					
				case "<slur":
				case "<octave-shift":
				case "<tremolo":
					j = line.search("start")
					//tick += (+ticks[i].duration)
					if (j != -1)
						s = toCheck[0]
					else
						s = ""
				break;	
				case "<tie type":	
				case "<ending":		
				case "<pedal":	
					j = line.search("start")
					tick += (+ticks[i].duration)
					if (j != -1)
						s = toCheck[0]
					else
						s = ""
				break;
				case "<words":
					tick += (+ticks[i].duration)
					s = strip(line)
				break
				case "pizz.":
				case ">Swing":
				case ">Vivace":	
				case "cresc.":	
				case "crescendo":	
				case"<mf":	
					console.log ("98 i line ", i + " " + line)
					tick += (+ticks[i].duration)
					//s = strip(line)
					s = toCheck[0]
				break;
				case "<arpeggiate":
					//console.log("61 tick duration ", tick + " " + ticks[i].duration)					
					if (type == 1) 
						s = toCheck[0]
					else
						s = ""
				break;
				case"<fifths":
					tick += (+ticks[i].duration)
					s = strip(line)
					console.log ("62 s line ", s + " " + line)
					s = (+s) + 6
					console.log ("64 s ", s )
					s = "Key Signature " + keys[s]
				break;
				case"<beats":
					tick += (+ticks[i].duration)
					s = strip(line) + "/"
					var s2 = ticks[(+i)+1].line
					s2 = strip(s2)
					s += s2
					console.log ("71 s ", s )
					s = "Time Signature " + s
				break;
				case"<clef":
					tick += (+ticks[i].duration)
					//s = strip(line) + "/"
					s = ticks[(+i)+1].line
					s = strip(s)
					s = "Clef " + s
					//console.log ("104 s ",ti s )
				break
				default:
					//tick -= (+ticks[i].duration)
					s = toCheck[0]
				break;						
			}	
			if (s != ""){
				// for regular notes we went a duration too far
				if (ticks[i].type == 1){
					tick -= ticks[i].duration
				}
				//console.log( "55 tick = ", tick )
				tick *= (480/divisions) // in MS a quarter note == 480
				//console.log( "57 tick = ", tick ) 
				//console.log("50 row s tick voice = ", i + " " + s + " " + tick + " " + voice)
				
				// measure number = i + 1
				for (var i = 0; i < mticks.length; i++){
					//console.log( "102 tick i mticks[i] = ", tick + " " + i + " " + mticks[i] )
					result = 0
					// tick can be a little off due to tuplets
					if (i > 0 && abs(mticks[i] - tick) < noise){
						//console.log("106 abs(mticks[i] - tick) = ", abs(mticks[i] - tick))
						result = i+1
						//console.log(s + " found at measure " + result.toFixed(2) + " in voice " + voice)
						output += s + " found at measure " + result.toFixed(2) + " in voice " + voice + "\n"
						// get out of te loop
						i = mticks.length
					}
					else if (mticks[i] > tick){
						if (i > 0) mlen = mticks[i] - mticks[i-1]
						else mlen = mticks[i+1] - mticks[i]
						//console.log( "mlen = ", mlen )
						// mticks went 1 too far
						//console.log( "118 i tick mticks[i-1] = ", i + " " + tick  + " " + mticks[i-1] )
						result = i + (tick - mticks[i-1])/mlen
						//console.log( "119 result = ", result )
						console.log(s + " found at measure " + result.toFixed(2) + " in voice " + voice)
						output += s + " found at measure " + result.toFixed(2) + " in voice " + voice + "\n"
						// get out of te loop
						i = mticks.length
					}
				}
			}					
		}
	}
	
	function tickObject(line, tick, voice, duration, type) {
		this.line = line;
		this.tick = tick;
		this.voice = voice;
		this.duration = duration;
		this.type = type;
	}
			
	onRun: {
		
        mxPath = curScore.path.substring(0, curScore.path.lastIndexOf("/")+1) + curScore.scoreName+".musicxml";
        writeScore(curScore, mxPath, "musicxml");
        var mxml = fid.read();
		
		var cursor = curScore.newCursor();
		//console.log ("mxml = ", mxml
        if (typeof curScore === 'undefined') {
            console.log ("All done");
            Qt.quit();
        }
        cursor.rewind(0);
		var mticks = []
        console.time("run") 
		// collect measure ticks
        while (cursor.segment) {
            mticks.push(cursor.tick)
            cursor.nextMeasure();					
        }
		// add a dummy measure so we can also scan the 'real' last measure
		var j = mticks.length -1
		var mlen = mticks[j] - mticks[j-1]
		//console.log ("mlen = ",mlen)
        mticks.push(mticks[j] + mlen)
		
		var l // line
		var j
		var tick = 0
		var voice = 1
		var duration = 0
		var divisions = 0
		var chord = false
		
		var lines = []
		var ticks = []
		var thisElement = []
	
		// collect the lines
        var i = mxml.search("\n")
		while (i != -1){
			l = mxml.substring(0,i);
			l = l.trim()
			lines.push (l)
			mxml = mxml.substring(i+1);
			i = mxml.search("\n")
		}
		// counts lines i the musicxml file
		// var c = 0
		
		// type 1: no chord no grace note
		// type 2: chord (grace note does not matter)
		// type 3: no chord grace note yes
		var type = 1
		//output += "File: " + curScore.scoreName + "\n";
		
		// create the tick objects
		for (var i in lines){
			j = lines[i].search("<divisions>")
			if (j != -1){
				divisions = strip(lines[i])
			}
			j = lines[i].search("<voice>")
			if (j != -1){
				voice = strip(lines[i])
				// chord = true for added chord notes & grace notes (don't include their duration)				
				if (type == 1){
					// thank you javascript for this inanity
					tick = (+tick) + (+duration)
				}
			}
			// musicxml considers all voices measure by measure and backs up for a measure length worth for the next track
			if (lines[i] == "<backup>"){
				// go to next line
				i++
				duration = strip(lines[i])
				tick -= duration
			}
			j = lines[i].search("<duration>")
			if (j != -1){
				duration = strip(lines[i])
			}
			j = lines[i].search("<fifths>")
			if (j != -1){
				//lines[i] = strip(lines[i])
				//tick = (+tick) + (+duration)
			}
			// this signals we are dealing with chord notes: ignore their durations
			if (lines[i] == "<chord/>"){
				chord = true
				type = 2
			}
			// we want to ignore their duration
			j = lines[i].search("<grace")
			if (j != -1){
				type = 3
			}
			// signals end of this note 
			if (lines[i] == "</note>"){
				chord = false
				type = 1
			}
			thisElement = new tickObject(lines[i],tick, voice, duration,type);
			ticks.push(thisElement); // push note object into ticks
		}// end create tick objects
		
		for (var j in ticks){
			 //console.log("ticks = ", j + " " + ticks[j].line  + " " + ticks[j].tick + " " + ticks[j].voice + " " + ticks[j].duration + " " + ticks[j].type)
			//output +=	"ticks = " + j + " " + ticks[j].line  + " " + ticks[j].tick + " " + ticks[j].voice + " " + ticks[j].duration + " " + ticks[j].type + "\n"			}
		}
		
		//throw new Error("message");
		var toCheck = [
			["8va alta", "<octave-shift"],
			["Accent", "<accent"],
			["Arpeggio", "<arpeggiate"],
			["Breath Mark", "<breath-mark"],
			["Cresc.", "cresc."],
			["Crescendo", "crescendo"],
			["Down bow", "<down-bow"],
			["Fermata", "<fermata"],
			["Grace note", "grace"],
			["Harmonic", "<harmonic"],
			["Key Signature", "<fifths"],
			["Key", "<clef"],
			["Marcato", "<marcato"],
			["mf", "<mf"], // other tempo
			["Mordent", "<mordent"],
			["Pedal", "<pedal"],
			["Pizz.", "pizz."],
			["Slur", "<slur"],
			["Staccato", "<staccato"],
			["Swing", ">Swing"],
			["Tempo", "<beat-unit"],
			["Tenuto", "<tenuto"],
			["Text", "<words"],
			["Tie", "<tie type"],
			["Time Signature", "<beats"],
			["Tremolo", "<tremolo"],
			["Trill", "<trill"],
			["Up bow", "<up-bow"],
			["Vivace", ">Vivace"],
			["Volta", "<ending"],
		];
			
		for (var j in ticks){
			//for (var i = 0; i < 2; i++){
			for (var i in toCheck){
				check(toCheck[i], j , ticks, mticks, divisions)
			}			
		}
		
		var rc = outfile.write(output);
            if (rc){ 
                  console.log("Log file has been  written to "+outfile.source);
                  proc.start("notepad "+outfile.source); // Windows
            } else {
                  console.log("Something went wrong. File cannot be written");
            }
		
        //console.log(mxml); // will print the file content
		console.timeEnd("run")
		Qt.quit();
	}
}// end on Run